/*************************
 * WikiLookRU.js
  * Author: TestPilot
 *
  *************************/

//      var FirstRun = db_pref.getBoolPref("WikiLookRU.firstrun");
var db_pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

//////////////////////////////////////////////////////////////////////
// Dev mode?
//////////////////////////////////////////////////////////////////////

var FL_devMode = true;
//var FL_devMode = false;


//////////////////////////////////////////////////////////////////////
// Data
//////////////////////////////////////////////////////////////////////

const FL_commonWord = ",WikiLookRU,";
 
// Wiktionary section names
const FL_Wiktionary_section_names = [
        "Abbreviation",
        "Acronym",
        "Adjective",
        "Adverb",
        "Anagrams",
        "Article",
        "Cardinal number",
        "Cardinal numeral",
        "Compounds",
        "Conjugation",
        "Conjunction",
        "Contraction",
        "Counter",
        "Declension",
        "Descendants",
        "Determiner",
        "Hiragana",
        "Idiom",
        "Infix",
        "Inflection",
        "Initialism",
        "Interjection",
        "Noun",
        "Number",
        "Numeral",
        "Ordinal number",
        "Ordinal numeral",
        "Participle",
        "Particle",
        "Phrase",
        "Pinyin syllable",
        "Prefix",
        "Preposition",
        "Pronoun",
        "Proper noun",
        "Proverb",
        "Quotations",
        "Romaji",
        "Trivia",
        "Verb",
        "Verb form",
        "Forme de verbe",
        "Adjectif",
        "Etymologie",
        ".C3.89tymologie",
        ".C3.89tymologie_2",
        "Nom commun",
        "Nom commun 1",
        "Nom commun 2",
        "Nom commun 3",
        "Anagrammes",
        "Prononciation",
        "Verbe",
        "Forme de nom commun",
        "Article indefini",
        "Article defini",
        "Adverbe",
        "Pronom",
        "Article_d.C3.A9fini",
        "Forme_d.E2.80.99adjectif",
        "Adjectif possessif",
        "Nom propre",
        "Forme d’adjectif",
        "Preposition",
        "Article partitif",
        "Particule",
        "Pr.C3.A9position",
        "Значение",
        "Синонимы",
        "Гиперонимы",
        "Гипонимы",
        "Антонимы",
        "Согипонимы",
        "Холонимы",
        "Меронимы",
        "Этимология",
        "Фразеологизмы",
        "Пословицы и поговорки",
        "Родственные слова",
        "Перевод",
];

 

//////////////////////////////////////////////////////////////////////
// Core Object
//////////////////////////////////////////////////////////////////////

WikiLookRU = function () {
        this._FL_initialized = false;
        this._FL_enabled = true;
        this._FL_ID = null;
        this._wordMonTimer = null;      // word monitor timer object
        this._mainWindow = null;
        this._currentDoc = null;
        this._shiftKey = null;
        this._initialized = true;
        this._eventRangeParent = null;
        this._eventRangeOffset = null;
        this._eventTarget = null;
        this._event = null;
        this._eventClientX = null;
        this._eventClientY = null;
        this._wordX = null;
        this._wordY = null;
        this._currentWord = "";
        this._lastWord = "";
        this._wordMonTimer = null;
        this._pref_WordMonTimerDelay = 750;     // in miliseconds
        this._pref_HideWhenMouseMove = false;   // hide definition when mouse moves
        this._pref_WindowOffsetX = 6;           
        this._pref_WindowOffsetY = 3;           
        this._pref_BlockBasicWords = true;              
        this._divId = "WikiLookRU_overlay_layout";
        this._div = null;
        this._divIsDisplayed = false;
        this._showDefinition = false;
        this._isRequestFetching = false;
        this._statusImageId = "WikiLookRU_StatusImage";
    this._mainLanguage = "Русский";
        this._mainLngFound = false;
        this._defFound = false;
        this._goForIt = false;
        this._thisIsAFormOf=false;
        this._outText = "";
        // color schemes
        this._linkColor = "#002BB8";
//      this._backgroundColor = "#C5FCDC";
        this._backgroundColor = "#BDFEDC";
        // AJAX object
        this._request = null;   

        // preference object
        this._pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
        this.init();
}

WikiLookRU.prototype.init = function() {
        if (this._FL_initialized == true) {
                return;
        }
        this._FL_initialized = true;
        this._FL_ID = ((new Date).getTime()).toString();

}


//////////////////////////////////////////////////////////////////////
// Global Raw Functions & Objects
//////////////////////////////////////////////////////////////////////

var FL_request = Object;

//////////////////////////////////////////////////////////////////////
// Event Handlers
//////////////////////////////////////////////////////////////////////

WikiLookRU.prototype.eventLoad = function(event) { WikiLookRU_Overlay.eventLoadImpl(event); } // fires once on each browser window open
WikiLookRU.prototype.eventLoadImpl = function(event) {
        this.loadPref();
        this._FL_enabled = true;
        this.updateStatusImage();
        var FirstRun = db_pref.getBoolPref("WikiLookRU.firstrun");
        if (FirstRun) {
        window.setTimeout(function() {
                        var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService();
                var wmed = wm.QueryInterface(Components.interfaces.nsIWindowMediator);
                var win = wmed.getMostRecentWindow("navigator:browser");
                        var content = win.document.getElementById("content");
                content.selectedTab = content.addTab("http://wikilook.mozdev.org/"); //this is help page are/will describe how to use WikiLookRU        
                        db_pref.setBoolPref("WikiLookRU.firstrun", false);
                }, 1250);
        }
}

WikiLookRU.prototype.eventUnload = function(event) { WikiLookRU_Overlay.eventUnloadImpl(event); } // fires once on each browser window close
WikiLookRU.prototype.eventUnloadImpl = function(event) {
}

WikiLookRU.prototype.eventFocus = function(event) { WikiLookRU_Overlay.eventFocusImpl(event); }
WikiLookRU.prototype.eventFocusImpl = function(event) {
        this.clearAll();
        this._currentDoc = event.target;

}

WikiLookRU.prototype.eventBlur = function(event) { WikiLookRU_Overlay.eventBlurImpl(event); }
WikiLookRU.prototype.eventBlurImpl = function(event) {
        this.clearAll();
}

WikiLookRU.prototype.eventClick = function(event) { WikiLookRU_Overlay.eventClickImpl(event); }
WikiLookRU.prototype.eventClickImpl = function(event) {
        this._currentDoc = this.getDoc(event);

        // Check whether the click is made in WikiLookRU window
        // to avoid "nullifying click" inside the WikiLookRU
        var isInFL_div = false;
        if (event.target.tagName == "A")
        {
                var p = event.target;
                var sentinel = 0;
                while (p.tagName != "HTML"  && isInFL_div == false)     {
                        sentinel++;
                        p = p.parentNode;
                        if(sentinel>20) {
                                return;
                        }
                };
        }
        if (isInFL_div == false)
        {
                this.clearAll();
        }

}
 
WikiLookRU.prototype.eventMouseMove = function(event) { WikiLookRU_Overlay.eventMouseMoveImpl(event); }
WikiLookRU.prototype.eventMouseMoveImpl = function(event) {
        if (!this._FL_enabled) return;
        if (this._pref_HideWhenMouseMove || this._isRequestFetching) {
                this.clearAll();
        } else {
                this.clearWordMonTimer();
                this.clearRequest();
        }

        // FL_currentDoc = event.target.ownerDocument;
        this._currentDoc = this.getDoc(event);
        this._eventTarget = event.target;
        if (this._eventTarget.tagName != "TEXTAREA" || this._eventTarget.tagName != "INPUT"  || this._eventTarget.tagName != "SELECT") {
                this._eventRangeParent = event.rangeParent;
                this._eventRangeOffset = event.rangeOffset;
                this._eventClientX = event.clientX;
                this._eventClientY = event.clientY;
                this._shiftKey = event.ctrlKey;
                this._wordMonTimer = setTimeout("WikiLookRU_Overlay.MouseMoveMon()",this._pref_WordMonTimerDelay);
        }

}

WikiLookRU.prototype.eventScroll = function(event) { WikiLookRU_Overlay.eventScrollImpl(event); }
WikiLookRU.prototype.eventScrollImpl = function(event) {
        if (!this._FL_enabled) return;
        //this.clearAll();
}

WikiLookRU.prototype.eventClickStatus = function(event) { WikiLookRU_Overlay.eventClickStatusImpl(event); }
WikiLookRU.prototype.eventClickStatusImpl = function(event) {
        if (event.button == 0){ //left click
                this._FL_enabled = !this._FL_enabled;
                
                // when turned off
                if (!this._FL_enabled) {
                        this._pref.setBoolPref("extensions.WikiLookRU.enabled", this._FL_enabled);
                        this.clearAll();
                        this.removeDiv();
                }
                this.updateStatusImage();
        }
}

//////////////////////////////////////////////////////////////////////
// Core Functions
//////////////////////////////////////////////////////////////////////

WikiLookRU.prototype.updateStatusImage = function() {
        var img =  document.getElementById(this._statusImageId);
        if (this._FL_enabled) {
                img.src = "chrome://WikiLookRU/skin/wiki_on_ru.png";
        } else {
                img.src = "chrome://WikiLookRU/skin/wiki_off_ru.png";
        }
}

WikiLookRU.prototype.loadPref = function() {
        //this._pref.getCharPref
        //this._pref.setCharPref
        //this._pref.getBoolPref
        //this._pref.setBoolPref
        
        try     { this._pref_WordMonTimerDelay = parseInt(this._pref.getCharPref("extensions.WikiLookRU.wordmondelay"));
        } catch (e)     {       this._pref.setCharPref("extensions.WikiLookRU.wordmondelay",this._pref_WordMonTimerDelay);
        }

        try     { this._FL_enabled = this._pref.getBoolPref("extensions.WikiLookRU.enabled");
        } catch (e)     { this._pref.setBoolPref("extensions.WikiLookRU.enabled",true);
        }

}

WikiLookRU.prototype.clearAll = function() { // get ready for new state
        this._mainLngFound=false;
        this.clearWordMonTimer();
        this.clearRequest();
        this.clearDisplay();
        this._currentDoc = null;
        this._currentWord = null;
        this._lastWord = null;
        this._shiftKey = null;
        this._defFound = false;
        this._goForIt = false;
        this._thisIsAFormOf=false;
}

WikiLookRU.prototype.clearWordMonTimer = function() {
        if (this._wordMonTimer != null) {
                clearTimeout(this._wordMonTimer);
                this._wordMonTimer = null;
        }
}

WikiLookRU.prototype.clearDisplay = function() {
        this.removeDiv();
        this._showDefinition = false;
}

WikiLookRU.prototype.clearRequest = function () {
        if (this._isRequestFetching) {
                this._isRequestFetching = false;
        }
        if (FL_request != null) {
                try {
                        FL_request.abort();     
                }
                catch (e) {
                }
                FL_request = null
        }
}

WikiLookRU.prototype.getDoc = function(event) {
        return event.target.ownerDocument;
        return window._content.document;
        return content.document;
        return //FL_currentDoc = content.document;
}

WikiLookRU.prototype.MouseMoveMon = function() { // Mouse Movement Monitor
        if (!this._FL_enabled) return;

        this.clearRequest();

        if (FL_devMode && false)        {
        }

        this._currentWord = this.getCurrentWord(this._eventRangeParent,this._eventRangeOffset,this._eventTarget);
        if (this._currentWord == null || this._currentWord.length < 2) return;
        this._currentWord = this.trim(this._currentWord);

        if (this._pref_BlockBasicWords) {
                if (FL_commonWord.indexOf(","+this._currentWord+",") != -1) {
                        this._showDefinition = true;
                        if(!this.attachDiv()) return;
                        this._div.style.left = this.getNewWindowX() + "px";
                        this._div.style.top = this.getNewWindowY() + "px";
                        this._div.innerHTML = "" + this._currentWord + " is your favourite FireFox Add-on:)";
                        this.showDiv();
                        return;
                }
        }

        // Valid word?
        if ( this._currentWord != null && this.isWord(this._currentWord) && this._currentWord.length > 1) {
                if (this._lastWord == this._currentWord ) return;
                this._lastWord = this._currentWord;
                this._currentWord=this._currentWord.replace(/'s$/, "" )
                this._currentWord=this._currentWord.replace(/’s$/, "" )
                // killing ' around words
                this._currentWord=this._currentWord.replace(/'(\S+)'/g, "$1")
                //this._currentWord=this._currentWord.replace(/\s'/g, "" )
                this._currentWord=this._currentWord.replace(/"/g, "" )
                this._currentWord=this._currentWord.replace(/'/, "%27" )
                this._showDefinition = true;
                if(!this.attachDiv()) return;
                this._div.style.left = this.getNewWindowX()+"px";
                this._div.style.top = this.getNewWindowY()+"px";
                this._div.innerHTML = "(looking up <b>"+ this._currentWord.replace("%27","\'" ) +"</b> from Wiktionary.org ...)";
                this.showDiv();
                this._isRequestFetching = true;
                if(!this.requestFetchWord(this._currentWord)){
                        // No article?
                        
                }
        }
}

WikiLookRU.prototype.getNewWindowX = function () {
        if (this._eventClientX + 400  + this._pref_WindowOffsetX > this._currentDoc.width ) {
                return (this._currentDoc.width - 400 > 0) ? (this._currentDoc.width - 400) : 0;
        }
        else {
                return this._eventClientX + this._pref_WindowOffsetX;
        }
}

WikiLookRU.prototype.getNewWindowY = function () {
        return this._eventClientY + this._currentDoc.documentElement.scrollTop + this._currentDoc.body.scrollTop + this._pref_WindowOffsetY;
}

WikiLookRU.prototype.formOf = function () {
        var wordtemp="";
        var word="";
        var pattern = 'luriel de <b><a target="_blank" style="color:#002BB8;font-weight:normal;font-size:12px;" href="http://ru.wiktionary.org/wiki/';
        var a = this._outText.indexOf(pattern);
        if (a!=-1) {
                word=this._outText.substring(a+pattern.length, this._outText.indexOf('" title="',a));
                wordtemp=word.substring(0,word.indexOf("#"));
        }
        if (word!="") {
                if (word.length>wordtemp.length&&wordtemp.length>0){word=wordtemp;}
                this._thisIsAFormOf=true;
                this._currentWord=word;
                this.requestFetchWord2(word);
                return;
        }

        word="";
        wordtemp="";
        pattern = 'state of being <a target="_blank" style="color:#002BB8;font-weight:normal;font-size:12px;" href="http://ru.wiktionary.org/wiki/';
        var a = this._outText.indexOf(pattern);
        if (a!=-1) {
                word=this._outText.substring(a+pattern.length, this._outText.indexOf('" title="',a));
                wordtemp=word.substring(0,word.indexOf("#"));
        }
        if (word!="") {
                if (word.length>wordtemp.length&&wordtemp.length>0){word=wordtemp;}
                this._thisIsAFormOf=true;
                this._currentWord=word;
                this.requestFetchWord2(word);
                return;
        }
                
        word="";
        wordtemp="";
        pattern = 'participle of <span class="mention"><a target="_blank" style="color:#002BB8;font-weight:normal;font-size:12px;" href="http://ru.wiktionary.org/wiki/';
        var a = this._outText.indexOf(pattern);
        if (a!=-1) {
                word=this._outText.substring(a+pattern.length, this._outText.indexOf('" title="',a));
                wordtemp=word.substring(0,word.indexOf("#"));
        }
        if (word!="") {
                if (word.length>wordtemp.length&&wordtemp.length>0) {
                        word=wordtemp;
                }
                this._thisIsAFormOf=true;
                this._currentWord=word;
                this.requestFetchWord2(word);
                return;
        }
        
        word="";
        wordtemp="";
        pattern = 'past of <span class="mention"><a target="_blank" style="color:#002BB8;font-weight:normal;font-size:12px;" href="http://ru.wiktionary.org/wiki/';
        var a = this._outText.indexOf(pattern);
        if (a!=-1) {
                word=this._outText.substring(a+pattern.length, this._outText.indexOf('" title="',a));
                wordtemp=word.substring(0,word.indexOf("#"));
        }
        if (word!="") {
                if (word.length>wordtemp.length&&wordtemp.length>0){word=wordtemp;}
                this._thisIsAFormOf=true;
                this._currentWord=word;
                this.requestFetchWord2(word);
                return;
        }
}

WikiLookRU.prototype.showDiv = function () {
        if (this._div != null && this._showDefinition == true) {
                this._div.style.display="block";
                //this._div.style.display="inline";
                this._divIsDisplayed = true;
        }
}

WikiLookRU.prototype.hideDiv = function() {
        if (this._div != null) {
                this._div.style.display="none";
        }
        this._divIsDisplayed = false;
}

WikiLookRU.prototype.attachDiv = function() {
        //this.removeDiv();
        if (this._showDefinition == false) {
                return false;
        }
        if (this._thisIsAFormOf==true) {
                return true;
        }
        var div;
        try {
                div=this._currentDoc.createElementNS("http://www.w3.org/1999/xhtml","XHTML");   
        } catch (e) {
                return false;
        }
        div.id = this._divId;
        //div.style.inline;
        div.style.position = "absolute";
        //div.style.left = "100px";
        //div.style.top = "200px";
        //div.style.height = "20px";
        div.style.maxWidth = "450px";
        div.style.lineHeight = "2.2";
        div.style.textAlign = "left";
        // try being defined by WikiLookRU.css in content 
        //div.className = "WikiLookRU_overlay_class";
        div.style.color = "#000000";
        div.style.fontSize = "12px";
        div.style.fontWeight = "normal";
        div.style.fontStyle = "normal";
        div.style.fontFamily = "arial,verdana,sans-serif";
        div.style.fontSizeAdjust = "none";
        div.style.fontStretch = "normal";
        div.style.fontVariant = "normal";
        div.style.lineHeight = "10px";
        div.style.backgroundColor = this._backgroundColor;
        div.style.background = this._backgroundColor;
        div.style.border = "2px solid #6EF7A7";
        div.style.borderBottomStyle = "outset";
        div.style.borderRightStyle = "outset";

    div.style.outlineColor = "#6EF7A7";
        
        div.style.margin = "2px 2px 2px 2px";
        div.style.padding = "3px 3px 3px 3px";
        div.style.cssFloat = "none";
        div.style.overflow = "hidden";
        div.style.zIndex = "32710";
        div.style.display = "none";
        div.style.verticalAlign = "middle";
        div.style.paddingStart = "5px";
        div.setAttribute('align', 'left');

        this._currentDoc.body.appendChild(div);
        this._div = this._currentDoc.getElementById(this._divId);
        this._div.className = "WikiLookRU_overlay_class";
        return true;
}

WikiLookRU.prototype.removeDiv = function() {

        if (this._div != null) {
                try {
                        this._currentDoc.body.removeChild(FL_div);
                }
                catch (err) {
                }
                this._divIsDisplayed = false;
                this._div = null;
        }

        try {
                if (this._currentDoc.getElementById(this._divId) != null) {
                        var t=this._currentDoc.getElementById(this._divId).parentNode;
                        t.removeChild(this._currentDoc.getElementById(this._divId));
                        this._currentDoc.removeChild(this._divId);
                }
        }
        catch (err) {
        }
        this._divIsDisplayed = false;
        this._div = null;
}

WikiLookRU.prototype.toCapitalCaseWL = function(words) {
var re = /\s/;
words = words.split(re);
re = /(\S)(\S+)/;
for (i = words.length - 1; i >= 0; i--) {
re.exec(words[i]);
words[i] = RegExp.$1.toUpperCase()
+ RegExp.$2.toLowerCase();
}
return words.join(' ');
}


WikiLookRU.prototype.responseFetchReal = function (response) {
        this._isRequestFetching = false;
        //var defFound = false;
        if (response.indexOf("Wiktionary does not yet have an entry for") == -1) {
///////////////////////
                var pattern="wiktionary.org/w/index.php?title=";
                var titleStarts=response.indexOf(pattern)
                var TitleName=response.substring(titleStarts+pattern.length, response.indexOf("&amp;action=",titleStarts+pattern.length));
//              if (TitleName.length>TitleNameTemp.length) {TitleName=TitleNameTemp;}
//              alert(TitleName);
///////////////////////
                var lngName="";
                var mlngstrStarts='<3543h1>'+this._mainLanguage+'<3534/h1>';
                var mlngstrStops='<345h1>';
                var mlngStart=response.indexOf(mlngstrStarts)+mlngstrStarts.length+1;
                if (mlngStart-mlngstrStarts.length-1==-1) {
                        mlngStart=response.indexOf(mlngstrStops);
                        if (this._goForIt==true&&this._defFound==true) {
                                this.formOf();
                                return true;
                        }
                } else {this._mainLngFound=true;}
                var mlngStops=response.indexOf(mlngstrStops, response.indexOf(mlngstrStops,response.indexOf(mlngstrStops)+mlngstrStops.length)+mlngstrStops.length);
                var tmp=response.substring(mlngStart,mlngStart+300);
                //var nameStarts=tmp.lastIndexOf('<h1>')+4;
                lngName=tmp.substring(tmp.indexOf('<34534h1>')+4,tmp.indexOf('<3453\h1>'));
                if (mlngStops!=-1){
                        //response=response.substring(mlngStart,mlngStops);
                }
//              if (lngName=="Fran.C3.A7ais"){lngName="Francais";} else {lngName=lngName.substring(0,lngName.indexOf('">'));}
////////////////////////
                this._outText = "";
                var sectionName = "";
                var secIdx=0;
                for(secIdx=0; secIdx < FL_Wiktionary_section_names.length; secIdx++) {
                        sectionName = FL_Wiktionary_section_names[secIdx];
                        r = false;
                        r = this.wiktionaryGetSection(response,sectionName);
                        if (r != false) {
                                this._outText += "<b>"+sectionName+"</b>"+r;
                                this._defFound = true;
                        }
                }
                if (this._defFound) {
                        this._outText = this.wiktionarySetStyle(this._outText);
                        if(!this.attachDiv()) return;
                        tStem = "";
                        this._div.style.left = this.getNewWindowX() + "px";
                        this._div.style.top =this.getNewWindowY() + "px";
                        // This is very strange - but next line needed so redirects from proper noun that starts with lower case are shown correctly, while not touching the way words in weird alphabets are shown, like ones in Amharic.
                        if (this._currentWord.length==TitleName.length) {this._currentWord=TitleName}
                        if (this._thisIsAFormOf==false) { 
                                this._div.innerHTML = ""; 
                        } else {
                                this._div.innerHTML =this._div.innerHTML +'<center><hr width="80%" align="center" border="2" noshade color="#F5F5F5"><\center><\hr><br>'; 
                                this._thisIsAFormOf=false;
                        }
                        this._div.innerHTML =this._div.innerHTML + "<b ><a target='_blank' style=\"color:"+this._linkColor+";\" href='http://ru.wiktionary.org/wiki/"+this._currentWord+"' style='font-size:12px;'>"+this._currentWord.replace("%27","\'").replace(/_/g," ")+"</a></b> "
                                                                +" &nbsp;" + tStem
                                                                +'<b><i><font size=-5 color=#660033>'+lngName.replace(/_/g," ")+' </font></b></i>&nbsp;( Look up "'+ this._currentWord.replace("%27","\'" ).replace(/_/g," ") +'" in '
                                                                +" <a target='_blank' style=\"color:"+this._linkColor+";\" href='http://ru.wikipedia.org/wiki/"+this._currentWord+"'>Wikipedia</a> "
                                                                +" )<br/><br/>"
                                                                +"<span style=\"display:block;font-family:arial;\">"
                                                                +this._outText
                                                                +"</span>";
                                                                +"(retrieved from <a target=_blank style=\"color:"+this._linkColor+";\" href=http://ru.wiktionary.org>wiktionary.org</a>)";
                        if((this._goForIt==true&&this._defFound==true)||(this._mainLngFound==true&&this._defFound==true)){
                                //this.removeDiv();
                                this.showDiv();
                                this.formOf();
                                return true;
                                }
                        return false;
                } else {
                        return false;
                }
        } else { 
                if (response.indexOf('<li><big>Did you mean <b><span id="did-you-mean"><a href="/wiki/')!=-1) {
                        var a=response.indexOf('<li><big>Did you mean <b><span id="did-you-mean"><a href="/wiki/');
                        var pattern='" title="';
                        var titleStarts=response.indexOf(pattern,a)
                        var TitleName=response.substring(titleStarts+pattern.length, response.indexOf('">',titleStarts+pattern.length));
                        this._isRequestFetching = true;
                        this._currentWord=TitleName;
                        this.requestFetchWord2(TitleName);
                        return true;
                }
                
        }
        
        return false;
}


WikiLookRU.prototype.responseFetch2 = function (response) {
        this._goForIt=true;
        if (this.responseFetchReal(response)==true){
                return;
        }       else {
                        // unable to parse the content
                        if(!this.attachDiv()) return;
                        this._div.style.left = this.getNewWindowX() + "px";
                        this._div.style.top = this.getNewWindowY() + "px";
                        this._div.innerHTML = "* Unable to parse the <a target='_blank' style=\"color:"+this._linkColor+";\" href='http://ru.wiktionary.org/wiki/"+this._lastWord+"'>"+this._lastWord+"</a> from <a target=_blank href=http://ru.wiktionary.org>wiktionary.org</a>";
                        this.showDiv();
                        //Killing "unable to parse" div in  1 sec
                        setTimeout(function(something) { return function() { something.removeDiv(); }; }(this), 3000);
        }
        
}



WikiLookRU.prototype.responseFetch = function (response) {
        this._defFound=false;
        this._mainLngFound=false;
        this._goForIt=false;
        if (this.responseFetchReal(response)==true){
                return;
        }       else {
                        if (this._currentWord==this._currentWord.toUpperCase()) {
                                this._currentWord=this._currentWord.toLowerCase();
                        } else {
                                if (this._currentWord==this.toCapitalCaseWL(this._currentWord)) {
                                        this._currentWord=this._currentWord.toLowerCase();
                                } else {
                                        this._currentWord=this.toCapitalCaseWL(this._currentWord);
                                };
                        }
                        this._isRequestFetching = true;
                        this.requestFetchWord2(this._currentWord);
        }       
}




WikiLookRU.prototype.requestFetchWord = function (word) {
        var defFound = false;

        try     {
                FL_request = new XMLHttpRequest();
                if (FL_request.readyState != 0) {
                        return;
                }
                var url="http://ru.wiktionary.org/wiki/"+ word;
                FL_request.open("GET", url, true);
                FL_request.send(null);
        }
        catch (e)       {
                return;
        }

        FL_request.onreadystatechange = function() {
                if (FL_request!=null) {
                        if (FL_request.readyState == 4) {
                                if (FL_request.status==200) {
                                        WikiLookRU_Overlay.responseFetch(FL_request.responseText);
                                }
                                else {
                                }
                        }
                }
        }
}

WikiLookRU.prototype.requestFetchWord2 = function (word) {
        var defFound = false;

        try     {
                FL_request = new XMLHttpRequest();
                if (FL_request.readyState != 0) {
                        return;
                }
                var url="http://ru.wiktionary.org/wiki/"+ word;
                FL_request.open("GET", url, true);
                FL_request.send(null);
        }
        catch (e)       {
                return;
        }

        FL_request.onreadystatechange = function() {
                if (FL_request!=null) {
                        if (FL_request.readyState == 4) {
                                if (FL_request.status==200) {
                                        WikiLookRU_Overlay.responseFetch2(FL_request.responseText);
                                }
                                else {
                                }
                        }
                }
        }
}



WikiLookRU.prototype.wiktionaryGetSection = function (sourceText,sectionName) {
        // Convert to lowercase to find pattern position.
        // Discard lowercase needle and hay later.
        var sNameLower = sectionName.replace(" ","_","ig"); //.toLowerCase();
        var patternLower = " <span class=\"mw-headline\">" + sNameLower + "</span></h4>";
        var sourceLower = sourceText;//.toLowerCase();
        var headPos = sourceLower.indexOf(patternLower);
        if ( headPos != -1 ) {
                var u = sourceText.substring(headPos+patternLower.length);
                u = this.cutHead_preserve("<ol>", u);
                if (u==null) {return false;}
        u = this.cutTail_preserve("</ol>", u);
                u = u.replace(" href=\""," target=\"_blank\" href=\"http://ru.wiktionary.org", "gi");
                return u;
        }
        return false;
}

WikiLookRU.prototype.wiktionarySetStyle = function (stxt) {
        var nomargin = "color:#000000;padding:0px 1px 1px 1px;margin:1px 1px 1px 4px;font-weight:normal;";
        //French Wiktionary  look and feel fix...
        stxt = stxt.replace("<dl>","","gi");
        stxt = stxt.replace("</dl>","","gi");


        //
        stxt = stxt.replace("<ol>","<ol style='padding:2px 2px 2px 10px;margin:2px 2px 2px 10px;'>","gi");
        stxt = stxt.replace("<dl style='","<dl style='"+nomargin+";","gi");
        stxt = stxt.replace("<dl>","<dl style='"+nomargin+";'>","gi");
        stxt = stxt.replace("<dd style='","<dd style='"+nomargin+";","gi");
        stxt = stxt.replace("<dd>","<dd style='"+nomargin+";'>","gi");
        stxt = stxt.replace("<li style='","<li style='"+nomargin+";font-family:arial;","gi");
        
        //Next lines are non essential lines that looks for "lazy mans" inclusion of context labels, ones that defined not by tamplate, but by parentheses. 
        stxt = stxt.replace(/<li>\(<i>([^\)]*)<\/i>\)/g, "<li><i><font size=-7 color=\"purple\">($1)</font></i>");
    stxt = stxt.replace(/<li>(\([^\)]*\))/g, "<li><i><font size=-7 color=\"purple\">$1</font></i>");
        //Formatting  actual context labels
        stxt = stxt.replace(/<span class="ib-comma"><span class="qualifier-comma">,<\/span><\/span>/g, ",");

        //to fix font size /color of links inside parenteses
        stxt = stxt.replace(/<span class="ib-brac"><span class="qualifier-brac">\((.[^\)]*?)(<a target="_blank" href=)(.*?)\)/g, "<span class=\"ib-brac\"><span class=\"qualifier-brac\">($1<a target=\"_blank\" style=\"color:brown;font-size:9px;\" href=$3)"); 
        stxt = stxt.replace(/<span class="ib-brac"><span class="qualifier-brac">\((.[^\)]*?)(<a target="_blank" href=)(.*?)\)/g, "<span class=\"ib-brac\"><span class=\"qualifier-brac\">($1<a target=\"_blank\" style=\"color:brown;font-size:9px;\" href=$3)"); 
        stxt = stxt.replace(/<span class="ib-brac"><span class="qualifier-brac">\((.[^\)]*?)(<a target="_blank" href=)(.*?)\)/g, "<span class=\"ib-brac\"><span class=\"qualifier-brac\">($1<a target=\"_blank\" style=\"color:brown;font-size:9px;\" href=$3)"); 

        
        stxt = stxt.replace(/<span class="ib-brac"><span class="qualifier-brac">\(<\/span><\/span><span class="ib-content"><span class="qualifier-content">(.*?)<\/span><\/span><span class="ib-brac"><span class="qualifier-brac">\)<\/span><\/span>/g, "<i><font size=-7 color=\"purple\">($1)</font></i>"); 
        stxt = stxt.replace("<li>","<li style='"+nomargin+";font-family:arial;list-style-image:none;line-height:100%;background-color:"+this._backgroundColor+";'>","gi");
        stxt = stxt.replace("<i>","<i style='color:#000000;font-weight:normal;font-family:arial;list-style-type:none;line-height:100%;background-color:"+this._backgroundColor+"'>","gi");

        //fixinf heperlink font size/color of the  links
        stxt = stxt.replace(/ href=/g, " style=\"color:"+this._linkColor+";font-weight:normal;font-size:12px;\" href="); 
        
        return stxt;
}



// Derived & Modified from BackWord
WikiLookRU.prototype.getCurrentWord = function(parent, offset, target) {

//    use locale;
        try     {
                if (parent.parentNode != target) {
                        return null;
                }
        }
        catch (e) {
                return null;
        }
        if (parent.nodeType != Node.TEXT_NODE) {
                        return null;
        }
        var container = parent.parentNode;
        if (container) {
                        var foundNode = false;
                        for (var c = container.firstChild; c != null; c = c.nextSibling) {
                                        if (c == parent) {
                                                        foundNode = true;
                                                        break;
                                        }
                        }
                        if (!foundNode) {
                                        return null;
                        }
        }
        var range = parent.ownerDocument.createRange();
        range.selectNode(parent);
        var str = range.toString();
        if (offset < 0 || offset >= str.length) {
                        return null;
        }
        var start = offset;
        var end = offset + 1;
        var valid_chars = /[a-zA-Zа-яА-Яa-z?-??-??-??-??-??'’?AE-]/;
        if (!valid_chars.test(str.substring(start, start + 1))) {
                        return null;
        }
        while (start > 0) {
                        if (valid_chars.test(str.substring(start - 1, start))) {
                                        start--;
                        } else {
                                        break;
                        }
        }
        while (end < str.length) {
                        if (valid_chars.test(str.substring(end, end + 1))) {
                                        end++;
                        } else {
                                        break;
                        }
        }
        var prottext = str.substring(start, end);
        if (prottext.length<2) { 
                return null;
        }
        if (this._shiftKey) {
                if(prottext.indexOf("d'")==0) {prottext=prottext.substring(2,prottext.length);}
                if(prottext.indexOf("d’")==0) {prottext=prottext.substring(2,prottext.length);}
                if(prottext.indexOf("l'")==0) {prottext=prottext.substring(2,prottext.length);}
                if(prottext.indexOf("l’")==0) {prottext=prottext.substring(2,prottext.length);}
                return prottext;
        } else {
                return null;
        }
        var a = document.commandDispatcher.focusedWindow.getSelection();
        var selectedText = a.toString();
        if (selectedText.length>50) { 
                return null;
        }
        valid_chars = /[a-zA-Zа-яА-Яa-z?-??-??-??-??-??'’?AE]/;
        while (!valid_chars.test(selectedText[selectedText.length-1])&&selectedText.length>2) {
                selectedText=selectedText.substring(0,selectedText.length-1);
        }
        while (!valid_chars.test(selectedText[0])&&selectedText.length>2) {
                selectedText=selectedText.substring(1,selectedText.length);
        }
    if (prottext.indexOf(selectedText)!=-1) {return selectedText;}
        
    if (prottext.length>6) {
                prottext=prottext.substring(0,prottext.length-2);
        }
        if (selectedText.indexOf(prottext)!=-1) {return selectedText;}
};


WikiLookRU.prototype.plainText = function(text_) {
    var text = FL_HTMLEncode(text_);
    text = text.replace(/\n/g, "<BR />");
    return text;
}
WikiLookRU.prototype.HTMLEncode = function(text) {
    text = text.replace(/&/g, "&amp;");
    text = text.replace(/"/g, "&quot;");
    text = text.replace(/</g, "&lt;");
    text = text.replace(/>/g, "&gt;");
    text = text.replace(/'/g, "&#146;");
    return text;
}
WikiLookRU.prototype.HTMLDecode = function(text) {
    text = text.replace(/&amp;/g, "&");
    text = text.replace(/&quot;/g, "\"");
    text = text.replace(/&lt;/g, "<");
    text = text.replace(/&gt;/g, ">");
    text = text.replace(/&#146;/g, "'");
    text = text.replace(/<BR \/>/g, "\n");
    return text;
}
WikiLookRU.prototype.isWord = function(str){
        var i=0;
        for(; i<str.length; i++){
                if (!this.isAlphabet(str.substr(i, 1))) {
                        return false;
                }
        }
        return true;
}

WikiLookRU.prototype.isAlphabet = function(str){
        var valid_chars = /[a-zA-Zа-яА-Яa-z?-??-??-??-??-??'’?AE-]/;
//      return valid_chars.test(str);
    return true;
}

WikiLookRU.prototype.isAlphaNumeric = function(str){
//    use locale;
        var valid_chars = /[a-zA-Zа-яА-Яa-z?-??-??-??-??-??'’?AE-]/;
//      return valid_chars.test(str);
        return true;
}

WikiLookRU.prototype.getTop = function(div){
        return parseInt(div.style.top.substr(0, div.style.top.length-2))
}

WikiLookRU.prototype.getLeft = function(div){
        return parseInt(div.style.left.substr(0, div.style.left.length-2))
}

WikiLookRU.prototype.stripHTML = function(oldString) {
        var newString = "";
        var inTag = false;
        for(var i = 0; i < oldString.length; i++) {
                if(oldString.charAt(i) == '<') inTag = true;
                if(oldString.charAt(i) == '>') {
                        inTag = false;
                        i++;
                }
                if(!inTag) newString += oldString.charAt(i);
        }
        return newString;
}

WikiLookRU.prototype.stripTags = function(oldString) {
        return oldString.replace(/(<([^>]+)>)/ig,"");
}


WikiLookRU.prototype.cutHead_preserve = function(strPattern, oldString) {
        i = oldString.indexOf(strPattern);
        if (i==-1) {
                return null;
        } else {
                return oldString.substring(i);
        }
}


WikiLookRU.prototype.cutTail_preserve = function(strPattern, oldString) {
        i = oldString.indexOf(strPattern);
        if (i==-1) {
                return null;
        } else {
                return oldString.substring(0, i + strPattern.length);
        }
}

WikiLookRU.prototype.trim = function(str){
        if (FL_devMode && true) {
        }
        return this.ltrim(this.rtrim(str));
}

WikiLookRU.prototype.rtrim = function(str){
        var v_length = str.length;
        if(v_length < 0) {
                return "";
        }
        var w_space = String.fromCharCode(32);
        var strTemp = "";
        var iTemp = v_length -1;
        while(iTemp > -1) {
                if(str.charAt(iTemp) == w_space) {
                        // do nothing
                }
                else
                {       strTemp = str.substring(0,iTemp +1);
                        break;
                }
                iTemp = iTemp-1;
        } //End While
        return strTemp;
} //End Function

WikiLookRU.prototype.ltrim = function(str){
        var w_space = String.fromCharCode(32);
        var v_length = str.length;
        if(v_length < 1){
                return "";
        }
        var strTemp = "";
        var iTemp = 0;
        while(iTemp < v_length){
                if(str.charAt(iTemp) == w_space){
                        //do nothing
                }
                else{
                        strTemp = str.substring(iTemp,v_length);
                        break;
                }
                iTemp = iTemp + 1;
        } //End While
        return strTemp;
} //End Function

